listPrimes :: [Int] -> [Int]
listPrimes list = (head list) : filter ((\x y -> (mod y x) /= 0) (head list)) (listPrimes (tail list))

primes :: [Int]
primes = listPrimes [2..]

elemOfSortedList :: Ord a => a -> [a] -> Bool
elemOfSortedList e [] = False
elemOfSortedList e (x:xs) | e == x = True
                          | e > x = (elemOfSortedList e xs)
                          | otherwise = False

isPrim :: Int -> Bool
isPrim x = x `elemOfSortedList` primes

-- Simply take the (n-1)th prime from the list
-- as there is no "0th" prime. The 1st prime is 2
prime :: Int -> Int
prime n = primes !! (n-1)


takeUpTo :: Ord a => a -> [a] -> [a]
takeUpTo e [] = []
takeUpTo e (x:xs) | e >= x = x:(takeUpTo e xs)
                  | otherwise = []

takePrimes :: Int -> [Int]
takePrimes n = takeUpTo n primes